<?php

/**
 * @author Kiruban
 * @copyright 2008
 * @site http://www.kiruban.fr
 * @mail webmaster@kiruban.fr
 */

class User {
	
	const GUEST = 0;
	const MEMBER = 1;
	const MODERATOR = 2;
	const ADMIN = 3;
	
	private $uid;
	private $fields;
	
	public function __construct()
	{
		$this->uid = null;
		$this->fields = array('username' => '', 'email' => '', 'password' => '', 'isActive' => false, 'permission' => 0);
	}
	 
    // override magic method to retrieve properties
    public function __get($field)
    {
        if ($field == 'userId')
        {
            return $this->uid;
        }
        else 
        {
            return $this->fields[$field];
        }
    }

    // override magic method to set properties
    public function __set($field, $value)
    {
        if (array_key_exists($field, $this->fields))
        {
            $this->fields[$field] = $value;
        }
    }
	

    // return if username is valid format
    public static function validateUsername($username)
    {
        return preg_match('/^[A-Z0-9]{2,20}$/i', $username);
    }
    
    // return if email address is valid format
    public static function validateEmailAddr($email)
    {
        return filter_var($email, FILTER_VALIDATE_EMAIL);
    }

    // return an object populated based on the record's user id
    public static function getById($userId)
    {
        $u = new User();
        $query = "SELECT m_username, m_email, m_password, m_status, m_permission FROM members WHERE m_id='".mysql_real_escape_string($userId, $GLOBALS['DB'])."'";
        $result = mysql_query($query, $GLOBALS['DB']);
        if (mysql_num_rows($result))
        {
            $row = mysql_fetch_assoc($result);
            $u->username = $row['m_username'];
			$u->email = $row['m_email'];
            $u->password = $row['m_password'];
            $u->isActive = $row['m_status'];
            $u->permission = $row['m_permission'];
            $u->uid = $userId;
        }
        mysql_free_result($result);
        return $u;
    }

    // return an object populated based on the record's username
    public static function getByUsername($username)
    {
        $u = new User();
		$query = "SELECT m_id, m_email, m_password, m_status, m_permission FROM members WHERE m_username='".mysql_real_escape_string($username, $GLOBALS['DB'])."'";
        $result = mysql_query($query, $GLOBALS['DB']);
        if (mysql_num_rows($result))
        {
            $row = mysql_fetch_assoc($result);
            $u->username = $username;
			$u->email = $row['m_email'];
            $u->password = $row['m_password'];
            $u->isActive = $row['m_status'];
            $u->permission = $row['m_permission'];
            $u->uid = $row['m_id'];
        }
        mysql_free_result($result);
        return $u;
    }

    // save the record to the database
    public function save()
    {
        if ($this->uid)
        {
            $query = sprintf('UPDATE members SET m_username = "%s", ' .
                'm_password = "%s", m_email = "%s", m_status = %d, ' .
                'm_permission = %d WHERE m_id = %d',
                mysql_real_escape_string($this->username, $GLOBALS['DB']),
                mysql_real_escape_string($this->password, $GLOBALS['DB']),
                mysql_real_escape_string($this->email, $GLOBALS['DB']),
                $this->isActive, $this->permission, $this->uid);
            return mysql_query($query, $GLOBALS['DB']);
        }
        else
        {
            $query = sprintf('INSERT INTO members (m_username, m_password, ' .
                'm_email, m_status, m_permission) VALUES ("%s", "%s", ' .
                '"%s", %d, %d)',
                mysql_real_escape_string($this->username, $GLOBALS['DB']),
                mysql_real_escape_string($this->password, $GLOBALS['DB']),
                mysql_real_escape_string($this->email, $GLOBALS['DB']),
                $this->isActive, $this->permission);
            if (mysql_query($query, $GLOBALS['DB']))
            {
                $this->uid = mysql_insert_id($GLOBALS['DB']);
                return true;
            }
            else
            {
                return false;
            } 
        }
    }

	// ... the rest of User beyond this point is left unchanged
    // set the record as inactive and return an activation token
    public function setPending()
    {
        $this->isActive = false;
        $this->save(); // make sure the record is saved

        $token = random_text(5);
        $query = sprintf('INSERT INTO tokens (m_id, t_key) ' . 
            'VALUES (%d, "%s")', $this->uid, $token);
        return (mysql_query($query, $GLOBALS['DB'])) ? $token : false;
    }

    // clear the user's pending status and set the record as active
    public function clearPending($token)
    {
        $query = sprintf('SELECT t_key FROM tokens WHERE m_id = %d ' . 
            'AND t_key= "%s"', $this->uid,
            mysql_real_escape_string($token, $GLOBALS['DB']));
        $result = mysql_query($query, $GLOBALS['DB']);
        if (!mysql_num_rows($result))
        {
            mysql_free_result($result);
            return false;
        }
        else
        {
            mysql_free_result($result);
            $query = sprintf('DELETE FROM tokens WHERE m_id = %d ' .
                'AND t_key = "%s"', $this->uid,
                mysql_real_escape_string($token, $GLOBALS['DB']));
            if (!mysql_query($query, $GLOBALS['DB']))
            {
                return false;
            }
            else
            {
                $this->isActive = true;
                return $this->save();
            }
        }
   }
   
   public static function isLogged()
   {
   		if(isset($_SESSION['access']))
		{
			if($_SESSION['access'] == TRUE)
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		else
		{
			return false;
		}
   }
   
}

?>