<?php
$UPLOAD_ID = ''; // Initialize upload id

require 'ubr_ini.php';
require 'ubr_lib.php';
require 'ubr_finished_lib.php';


header('Content-type: text/html; charset=UTF-8');
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Last-Modified: ' . date('r'));
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: post-check=0, pre-check=0', false);
header('Pragma: no-cache');

if (isset($_GET['upload_id']) && preg_match("/^[a-zA-Z0-9]{32}$/", $_GET['upload_id'])) {
    $UPLOAD_ID = $_GET['upload_id'];
} elseif (isset($_GET['about'])) {
    kak("<u><b>UBER UPLOADER FINISHED PAGE</b></u><br>UBER UPLOADER VERSION =  <b>" .
        $UBER_VERSION . "</b><br>UBR_FINISHED = <b>" . $THIS_VERSION . "<b><br>\n", 1,
        __line__, $PATH_TO_CSS_FILE);
} else {
    kak("<span class='ubrError'>ERROR</span'>: Invalid parameters passed<br>", 1,
        __line__, $PATH_TO_CSS_FILE);
}

//Declare local values
$_XML_DATA = array(); // Array of xml data read from the upload_id.redirect file
$_CONFIG_DATA = array(); // Array of config data read from the $_XML_DATA array
$_POST_DATA = array(); // Array of posted data read from the $_XML_DATA array
$_FILE_DATA = array(); // Array of 'FileInfo' objects read from the $_XML_DATA array
$_FILE_DATA_TABLE = ''; // String used to store file info results nested between <tr> tags
$_FILE_DATA_EMAIL = ''; // String used to store file info results

$xml_parser = new XML_Parser; // XML parser
$xml_parser->setXMLFile($TEMP_DIR, $_REQUEST['upload_id']); // Set upload_id.redirect file
$xml_parser->setXMLFileDelete($DELETE_REDIRECT_FILE); // Delete upload_id.redirect file when finished parsing
$xml_parser->parseFeed(); // Parse upload_id.redirect file

// Display message if the XML parser encountered an error
if ($xml_parser->getError()) {
    kak($xml_parser->getErrorMsg(), 1, __line__, $PATH_TO_CSS_FILE);
}

$_XML_DATA = $xml_parser->getXMLData(); // Get xml data from the xml parser
$_CONFIG_DATA = getConfigData($_XML_DATA); // Get config data from the xml data
$_POST_DATA = getPostData($_XML_DATA); // Get post data from the xml data
$_FILE_DATA = getFileData($_XML_DATA); // Get file data from the xml data


debug("<br><u>XML DATA</u>", $_XML_DATA);
debug("<u>CONFIG DATA</u>", $_CONFIG_DATA);
debug("<u>POST DATA</u>", $_POST_DATA);
debug("<u>FILE DATA</u><br>", $_FILE_DATA);


//Create file upload table
$_FILE_DATA_TABLE = getFileDataTable($_FILE_DATA, $_CONFIG_DATA, $_POST_DATA);

// Create and send email
if ($_CONFIG_DATA['send_email_on_upload']) {
    emailUploadResults($_FILE_DATA, $_CONFIG_DATA, $_POST_DATA);
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>Uber-Uploader - Free File Upload Progress Bar</title>
    <meta http-equiv="content-type" content="text/html; charset=us-ascii" />
    <meta http-equiv="pragma" content="no-cache" />
    <meta http-equiv="cache-control" content="no-cache" />
    <meta http-equiv="expires" content="-1" />
    <meta name="robots" content="none" />
    <link rel="stylesheet" type="text/css" href="<?php print $PATH_TO_CSS_FILE; ?>" />
    <style type="text/css">
    /*<![CDATA[*/
    div.c1 {text-align: center}
    /*]]>*/
    </style>
</head><?php if ($_CONFIG_DATA['embedded_upload_results'] == 1) {
    scriptParent();
} ?>

<body class="ubrBody">
    <div class="ubrWrapper_c1">
        <br />
        <br />
         <?php print $_FILE_DATA_TABLE; ?>
        <br />
         <?php if ($_CONFIG_DATA['embedded_upload_results'] != 1) { ?>
        <br />
        <input type="button" value="Go Back" onclick="javascript:location.href='ubr_file_upload.php'" /> <?php } ?>
    </div>
</body>
</html>
