<?php

// Output a message to screen and exit
function kak($msg, $exit_ubr, $line, $path_to_css_file = 'images/ubr.css')
{
    print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
    print "<html>\n";
    print "		<head>\n";
    print "			<title>Uber-Uploader - Free File Upload Progress Bar</title>\n";
    print "			<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n";
    print "			<meta http-equiv=\"Pragma\" content=\"no-cache\">\n";
    print "			<meta http-equiv=\"cache-control\" content=\"no-cache\">\n";
    print "			<meta http-equiv=\"expires\" content=\"-1\">\n";
    print "			<meta name=\"robots\" content=\"none\">\n";
    print "			<link rel=\"stylesheet\" type=\"text/css\" href=\"$path_to_css_file\">\n";
    print "		</head>\n";
    print "		<body class=\"ubrBody\">\n";
    print "			<div align='center'>\n";
    print "				<br>\n";
    print "				$msg\n";
    print "				<br>\n";
    print "				<!-- kak on line $line -->\n";
    print "			</div>\n";
    print "		</body>\n";
    print "</html>\n";

    if ($exit_ubr) {
        exit;
    }
}

// Read a file
function readUberFile($file, $debug_ajax = 0)
{
    if (is_file($file)) {
        if (is_readable($file)) {
            $file_contents = '';

            if (function_exists('file_get_contents')) {
                if ($file_contents = file_get_contents($file)) {
                    return $file_contents;
                } else {
                    if ($debug_ajax) {
                        showDebugMessage("Failed to read file contents:" . $file);
                    }
                    return false;
                }
            } else {
                if (($fh = fopen($file, "rb")) !== false) {
                    if ($file_contents = fread($fh, @filesize($file))) {
                        @fclose($fh);
                        return $file_contents;
                    } else {
                        if ($debug_ajax) {
                            showDebugMessage("Failed to fread file:" . $file);
                        }
                        return false;
                    }
                } else {
                    if ($debug_ajax) {
                        showDebugMessage("Failed to open file:" . $file);
                    }
                    return false;
                }
            }
        } else {
            if ($debug_ajax) {
                showDebugMessage("Failed to read file:" . $file);
            }
            return false;
        }
    } else {
        if ($debug_ajax) {
            showDebugMessage("Failed to find file:" . $file);
        }
        return false;
    }
}

function showAlertMessage($message, $exit_ubr)
{
    echo "if(typeof showAlertMessage == 'function'){ showAlertMessage(" . '"' . $message .
        '"' . "); }";

    if ($exit_ubr) {
        exit();
    }
}

#Generate a 32 character string
function generateUploadID()
{
    return md5(uniqid(mt_rand(), true));
}

# Javascript function wrappers
function showDebugMessage($message)
{
    echo "if(typeof showDebugMessage == 'function'){ showDebugMessage(" . '"' . $message .
        '"' . "); }";
}
function stopUpload()
{
    echo "if(typeof stopUpload == 'function'){ stopUpload(); }";
}
function startUpload($upload_id, $debug_upload)
{
    echo "if(typeof startUpload == 'function'){ startUpload(" . '"' . $upload_id .
        '",' . $debug_upload . "); }";
}
function startProgressBar($upload_id, $total_upload_size, $start_time)
{
    echo "if(typeof startProgressBar == 'function'){ startProgressBar(" . '"' . $upload_id .
        '","' . $total_upload_size . '","' . $start_time . '"' . "); }";
}
function setProgressStatus($total_bytes_read, $files_uploaded, $current_filename,
    $bytes_read, $lapsed_time)
{
    echo "if(typeof setProgressStatus == 'function'){ setProgressStatus(" . $total_bytes_read .
        "," . $files_uploaded . ",'" . $current_filename . "'," . $bytes_read . "," . $lapsed_time .
        "); }";
}
function stopDataLoop()
{
    echo "if(typeof stopDataLoop == 'function'){ stopDataLoop(); }";
}
function hideProgressBar()
{
    echo "if(typeof hideProgressBar == 'function'){ hideProgressBar(); }";
}
function getProgressStatus($get_status_speed)
{
    echo "if(typeof getProgressStatus == 'function'){ setTimeout('getProgressStatus()', $get_status_speed); }";
}

////////////////////////////////////////////////////////////////////////////////
// Output array to screen (debug, debug_var, next_div, debug_colorize_string)
// Contributor: http://www.php.net/manual/en/function.print-r.php
////////////////////////////////////////////////////////////////////////////////
function debug($name, $data)
{
    ob_start();
    print_r($data);
    $str = ob_get_contents();
    ob_end_clean();
    debug_var($name, $str);
}

function debug_var($name, $data)
{
    $captured = preg_split("/\r?\n/", $data);

    print "<script>function toggleDiv(num){var span = document.getElementById('d'+num);var a = document.getElementById('a'+num);var cur = span.style.display;if(cur == 'none'){a.innerHTML = '-';span.style.display = 'inline';}else{a.innerHTML = '+';span.style.display = 'none';}}</script>";
    print "<b>$name</b>\n";
    print "<pre>\n";

    foreach ($captured as $line) {
        print debug_colorize_string($line) . "\n";
    }

    print "</pre>\n";
}

function next_div($matches)
{
    static $num = 0;
    ++$num;
    return "$matches[1]<a id=a$num href=\"javascript: toggleDiv($num)\">+</a><span id=d$num style=\"display:none\">(";
}
function debug_colorize_string($string)
{
    $string = preg_replace("/\[(\w*)\]/i", '[<font color="red">$1</font>]', $string);
    $string = preg_replace_callback("/(\s+)\($/", 'next_div', $string);
    $string = preg_replace("/(\s+)\)$/", '$1)</span>', $string);
    $string = str_replace('Array', '<font color="blue">Array</font>', $string);
    $string = str_replace('=>', '<font color="#556F55">=></font>', $string);

    return $string;
}

?>